from .lua_globals import argumentValidation

def __insert(args):
	if len(args) > 0:
		arg = {'table': args[0], 'index': -1, 'value': None}
		if len(args) == 2:
			arg['value'] = args[1]
		elif len(args) >= 3:
			arg['index'] = args[1]
			arg['value'] = args[2]
	else:
		arg = {'index': None}
	if arg['index'] == -1:
		args[0][__maxn([arg['table']])+1] = arg['value']
	elif arg['index']:
		i = arg['index']
		newValues = {arg['index']: arg['value']}
		while i in arg['table']:
			newValues[i+1] = arg['table'][i]
			i += 1
		args[0].update(newValues)

def __remove(args):
	if len(args) > 0:
		arg = {'table': args[0], 'index': -1}
		if len(args) >= 2:
			arg['index'] = args[1]
	else:
		arg = {'index': None}
	if len(arg['table']) > 0:
		if arg['index'] == -1:
			index = __maxn([args['table']])
			value = arg['table'][index]
			del args[0][index]
		elif arg['index']:
			value = arg['table'][arg['index']]
			i = arg['index']
			while i+1 in arg['table']:
				args[0][i] = arg['table'][i+1]
				i += 1
			del args[0][i]
		else:
			value = None
	else:
		value = None
	return value

def __maxn(args):
	if len(args) > 0:
		arg = {"table": args[0]}
	else:
		arg = {"table": None}
	
	if arg["table"]:
		n = 0
		if isinstance(arg["table"], dict):
			for i in arg["table"].keys():
				if isinstance(i, int) and i > n:
					n = i
		return n
	else:
		return 0

def __sort(args):
	if len(args) > 0:
		arg = {'table': args[0], 'less_then': None}
		if len(args) >= 2:
			arg['less_then'] = args[1]
	else:
		arg = {'table': None}
	if arg['table']:
		table = []
		keys = []
		less_then = arg['less_then']
		if not less_then:
			less_then = lambda a, b: a < b
		i = 1
		while i in arg['table']:
			val = arg['table'][i]
			if len(table) == 0:
				table.append(val)
			else:
				for j in range(len(table)):
					if less_then(val, table[j]):
						table = table[:j] + [val] + table[j:]
						break
					elif j >= len(table)-1:
						table.append(val)
			keys.append(i)
			i += 1

		args[0].update(zip(keys, table))

def __concat(args):
	if len(args) > 0:
		arg = {'table': args[0], 'sep': '', 'start': 0, 'end': len(args[0])}
		if len(args) == 2:
			arg['sep'] = args[1]
		elif len(args) == 3:
			arg['sep'] = args[1]
			arg['start'] = args[2]
		elif len(args) >= 4:
			arg['sep'] = args[1]
			arg['start'] = args[2]
			arg['end'] = args[2]
	else:
		arg = {'table': None}
	text = ''
	if arg['table']:
		i = arg['start']
		while i in arg['table'] and i <= arg['end']:
			text = text + str(arg['table'][i])
			if i < arg['end']:
				text = text + arg['sep']
	return text

table = {
  'insert': lambda *args: __insert(argumentValidation(args)),
  'remove': lambda *args: __remove(argumentValidation(args)),
  'maxn': lambda *args: __maxn(argumentValidation(args)),
  'sort': lambda *args: __sort(argumentValidation(args)),
  'concat': lambda *args: __concat(argumentValidation(args)),
}