from os.path import isfile, exists
from os import makedirs
from ..tf_util.base_functions import LuaExportFunctionProto

def write_var_struct(output, var, var_name, soffset, newline, comma = True):
	vartype = str(type(var))
	if var_name != "":
		if str(type(var_name)) != "<class 'str'>" or " " in var_name:
			output.write(soffset * "\t" + "[" + str(var_name) + "] = ")
		else:
			output.write(soffset * "\t" + var_name + " = ")
	if vartype in {"<class 'list'>", "<class 'Color'>", "<class 'Vector'>", "<class 'bpy_prop_array'>"}:
		shortform = False
		start = "{\n" + (soffset + 1) * "\t"
		end = "\n" + soffset * "\t" + "}"
		if 0 < len(var) < 4:
			shortform = False
			vartypechild = str(type(var[0]))
			if vartypechild in ("<class 'int'>", "<class 'long'>", "<class 'float'>"):
				start = "{ "
				end = "}"
		output.write(start)
		for i in range(0, len(var)):
			write_var_struct(output, var[i], "", soffset+1, False)
			if not shortform and str(type(var[i])) in {"<class 'list'>", "<class 'dict'>", "<class 'str'>"} and i < len(var)-1:
				output.write("\n" + (soffset + 1) * "\t")
			else:
				output.write(" ")
		output.write(end)
	elif vartype in {"<class 'dict'>"}:
		output.write("{\n")
		for key in sorted(list(var.keys())):
			if str(type(key)) != "<class 'str'>" or key[0:2] != "__":
				write_var_struct(output, var[key], key, soffset+1, True)
		output.write(soffset * "\t" + "}")
	elif (vartype == "<class 'int'>") or (vartype == "<class 'long'>") or (vartype == "<class 'float'>"):
		output.write(str(round(var, 5)))
	elif vartype == "<class 'str'>":
		if var[:2] == "_(":
			output.write(var)
		else:
			output.write('"' + var + '"')
	elif vartype == "<class 'bool'>":
		if var: output.write("true")
		else: output.write("false")
	elif isinstance(var, LuaExportFunctionProto):
		output.write("%s(" % var.name)
		for i in range(0, len(var.params)):
			if (i > 0):
				output.write(", ")
			write_var_struct(output, var.params[i], "", soffset+1, False, False)
		output.write(")")
	else:
		print("Unknow export vartype", vartype) 
	
	if comma:
		output.write(",")
	if newline:
		output.write("\n")
	
def write_var_struct_string(var, var_name, soffset, newline, comma = True):
	vartype = str(type(var))
	output = ""
	if var_name != "":
		if str(type(var_name)) != "<class 'str'>" or " " in var_name:
			output += soffset * "\t" + "[" + str(var_name) + "] = "
		else:
			output += soffset * "\t" + var_name + " = "
	if vartype in {"<class 'list'>", "<class 'Color'>", "<class 'Vector'>", "<class 'bpy_prop_array'>"}:
		shortform = False
		start = "{\n" + (soffset + 1) * "\t"
		end = "\n" + soffset * "\t" + "}"
		if 0 < len(var) < 4:
			shortform = False
			vartypechild = str(type(var[0]))
			if vartypechild in ("<class 'int'>", "<class 'long'>", "<class 'float'>"):
				start = "{ "
				end = "}"
		output += start
		for i in range(0, len(var)):
			output += write_var_struct_string(var[i], "", soffset+1, False)
			if not shortform and str(type(var[i])) in {"<class 'list'>", "<class 'dict'>", "<class 'str'>"} and i < len(var)-1:
				output += "\n" + (soffset + 1) * "\t"
			else:
				output += " "
		output += end
	elif vartype in {"<class 'dict'>"}:
		output += "{\n"
		for key in sorted(list(var.keys())):
			if str(type(key)) != "<class 'str'>" or key[0:2] != "__":
				output += write_var_struct_string(var[key], key, soffset+1, True)
		output += soffset * "\t" + "}"
	elif (vartype == "<class 'int'>") or (vartype == "<class 'long'>") or (vartype == "<class 'float'>"):
		output += str(round(var, 5))
	elif vartype == "<class 'str'>":
		if var[:2] == "_(":
			output += var
		else:
			output += '"' + var + '"'
	elif vartype == "<class 'bool'>":
		if var: output += "true"
		else: output += "false"
	elif isinstance(var, LuaExportFunctionProto):
		output += "%s(" % var.name
		for i in range(0, len(var.params)):
			if (i > 0):
				output += ", "
			output += write_var_struct_string(var.params[i], "", soffset+1, False, False)
		output += ")"
	else:
		print("Unknow export vartype", vartype) 
	
	if comma:
		output += ","
	if newline:
		output += "\n"
		
	return output